"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Logger = void 0;

var _debug = _interopRequireDefault(require("debug"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

_debug["default"].enable('*:info,*:warn,*:error,*:debug');

var isNode = new Function('try {return this===global;}catch(e){return false;}');

var Logger = /*#__PURE__*/function () {
  function Logger(name) {
    _classCallCheck(this, Logger);

    _defineProperty(this, "_infoLogger", void 0);

    _defineProperty(this, "_debugLogger", void 0);

    _defineProperty(this, "_warnLogger", void 0);

    _defineProperty(this, "_errorLogger", void 0);

    name = name.replace(/\s+/g, '-').toLowerCase();
    var log = (0, _debug["default"])(name);
    this._infoLogger = log.extend('info');
    this._warnLogger = log.extend('warn');
    this._errorLogger = log.extend('error');
    this._debugLogger = log.extend('debug');
  }

  _createClass(Logger, [{
    key: "info",
    value: function info(formatter) {
      for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }

      this._infoLogger.apply(this, [formatter].concat(args));
    }
  }, {
    key: "warn",
    value: function warn(formatter) {
      for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
        args[_key2 - 1] = arguments[_key2];
      }

      this._warnLogger.apply(this, [formatter].concat(args));
    }
  }, {
    key: "error",
    value: function error(formatter) {
      for (var _len3 = arguments.length, args = new Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
        args[_key3 - 1] = arguments[_key3];
      }

      this._errorLogger.apply(this, [formatter].concat(args));
    }
  }, {
    key: "debug",
    value: function debug(formatter) {
      for (var _len4 = arguments.length, args = new Array(_len4 > 1 ? _len4 - 1 : 0), _key4 = 1; _key4 < _len4; _key4++) {
        args[_key4 - 1] = arguments[_key4];
      }

      if (Logger.isDebug) this._debugLogger.apply(this, [formatter].concat(args));
    }
  }]);

  return Logger;
}();

exports.Logger = Logger;

_defineProperty(Logger, "isDebug", isNode() && process.env.NODE_ENV !== 'production');
//# sourceMappingURL=index.js.map